Wikimedia Developer Summit 2018 Topic: Embracing Open Source Software
Closed, ResolvedPublic

Description

Participants, please read/think about/research these, ahead of time:

  • Session description:
    • In this session we will explore what it means to embrace open source software and how we can utilize Wikimedia’s already existing strengths to help the wider Open Source Community as a whole
  • Session Goals:
    • Formulate the direction and general focus areas to concentrate on to have Wikimedia be a leader in relevant Open Source tools for the wider Open Source community
  • Guiding topics
    • The WMF should commit to using open source internally even when inconvenient
    • The WMF should commit to being truly open source (easy install, good docs, easy to contribute)
    • The WMF should commit to encouraging downstream usage of WMF libraries
    • The WMF should commit to being involved with upstream projects
  • Pre-event questions for discussion
    • What tools do we develop that will help the wider Open Source community deliver knowledge to the world? (eg, Language support, etc)
    • What aspects of MediaWiki are useful to work both in- and out of the MediaWiki environment, to benefit tool/Wikimedia Cloud developers or wider OSS communities
    • How can we keep our software to the same standards we hold other open-source software?
    • How can we influence the larger OSS community? (Are there other external tools we should upstream to, or participate in, etc)
    • Are there problems/challenges that we are in a position to help solve for ourselves and other OSS communities?
    • How can we outreach and market our open source code and tooling
    • Can this strategy help in scaling the contributor experience? Allowing more contributors participate in wider-impact tools for the OSS community at large?
    • Tools outside mediawiki, i.e cumin, pybal as a standalone tool.
    • In which focus area we have a unique value we can lead in (c.f language support, data related tooling,
  • Related position statements:
  • Related background reading:

Session notes:


Topic Leaders (@Matanya @MSchottlender-WMF @Jamesmontalvo3), please

  • Add more details to this task description,
  • Coordinate any pre-event discussions (here, IRC, email, hangout, etc),
  • Outline the plan for discussing this topic at the Developer Summit.
  • Optionally, include what it will not try to solve.
  • Update this task with summaries of any pre-event discussions.
  • Include ways for people not attending to be involved in discussions before the summit and afterwards.

This is one of the 8 Wikimedia Developer Summit 2018 topics.


Post-event Summary:

  • ...

Action items:

  • ...
Rfarrand triaged this task as Normal priority.
Restricted Application added a subscriber: Aklapper. · View Herald TranscriptDec 20 2017, 12:08 AM
Aklapper renamed this task from Wikimedia Developer Summit 218 Topic: Embracing Open Source Software to Wikimedia Developer Summit 2018 Topic: Embracing Open Source Software.Dec 20 2017, 12:11 AM
bd808 added a subscriber: bd808.Dec 20 2017, 12:30 AM
Anomie added a subscriber: Anomie.Dec 20 2017, 2:17 PM
debt edited subscribers, added: debt; removed: hey_ok_deb.Dec 20 2017, 5:10 PM
Quiddity updated the task description. (Show Details)Dec 23 2017, 12:50 AM
Quiddity updated the task description. (Show Details)
Tpt added a subscriber: Tpt.Jan 8 2018, 5:57 PM
brion added a subscriber: brion.Jan 9 2018, 9:30 PM
Quiddity updated the task description. (Show Details)Jan 9 2018, 9:31 PM
Quiddity added a subscriber: MSchottlender-WMF.
Matanya updated the task description. (Show Details)Jan 17 2018, 7:02 PM
Quiddity updated the task description. (Show Details)Jan 17 2018, 10:39 PM

How can we influence the larger OSS community? (Are there other external tools we should upstream to, or participate in, etc)
[...]
How can we outreach and market our open source code and tooling
Can this strategy help in scaling the contributor experience? Allowing more contributors participate in wider-impact tools for the OSS community at large?

We often subconsciously divide our software into:

  1. "Ours"
  2. "Upstream"

#1 includes things that are inherently specific to us, like MW and certain extensions, but also certain libraries and tools. We often want to get more third-party contributors and users, but often don't get as many as we hope (especially for the libraries/tools).

#2 includes things like HHVM and Elasticsearch. We do make significant contributions here.

I propose we create a third mental category:

  1. "Partnership" (or maybe better "Community").

#3 would be projects where we are major active (and often ongoing) contributors (and possibly initiate), but there are also other major active contributors. Moreover, this involves thinking about it in a different way, possibly from the beginning.

Instead of Wikimedia running an open source project that is intended for re-use, we could start/join a partnership or a new community (not the "Wikimedia technical community", but "a freestanding healthy technical community Wikimedia developers contribute to").

This can be done formally (by running the project through an organization like the Apache Software Foundation or Free Software Foundation) or informally (keeping it in Gerrit but thinking about the project differently).

This could helpful even for smaller projects, but for larger projects (machine translation, open standards/codecs, etc.) (these, and more, are often too big to do on our own, yet essential to our mission), this other way of working may be critical.

See position papers by Birgit Müller and myself.

This is one of our three topics for "Growing the MediaWiki Technical Community" (T183318: Wikimedia Developer Summit 2018 Topic: Growing the MediaWiki Technical Community), but also important and relevant here.

Mholloway updated the task description. (Show Details)Jan 18 2018, 9:23 PM

Other repositories that are potentially useful outside WMF:

Other repositories that are potentially useful outside WMF:

See also T171073: Promote FLOSS libraries developed by the Foundation/movement.

debt added a comment.Jan 19 2018, 2:31 AM

Howdy all!

I'll be the facilitator for this particular session - let me know if there is anything I can help with in my duties to keep the conversation flowing constructively during the session. :)

Cheers!

Qgil added a subscriber: Qgil.Jan 19 2018, 10:56 AM
Joe added a subscriber: Joe.Jan 20 2018, 3:47 PM

Reading through the position statements [1], I think the main points can be summarized into the following four actions the WMF should take. The position statements that support each action are listed as well.

  1. The WMF should commit to using open source internally even when inconvenient: Holloway, Flaschen
  2. The WMF should commit to being truly open source (easy install, good docs, easy to contribute): Tijhof, Montalvo [2][3]
  3. The WMF should commit to being involved with upstream projects: Moses, Andreescu
  4. The WMF should commit to encouraging downstream usage of WMF libraries, etc: Schottlender, Shorland

Do people agree this seems like a good breakdown? Perhaps the session should try to determine priorities. The list above implies no priority...I think it was just the order they came up in position statements.

[1] https://wikifarm.wmflabs.org/devsummit/index.php/Session:8
[2] https://wikifarm.wmflabs.org/devsummit/index.php/Statement:31
[3] I was asked to help lead the topic, but my position statement [2] isn't listed on the topic. I'm not sure if that was intentional. It doesn't actually say the words "open source" but Timo's position made me think that "because open source" is the "why" behind my position.

Qgil awarded a token.Jan 22 2018, 10:46 AM
Qgil added a comment.Jan 22 2018, 10:50 AM

A few weeks ago I stumbled upon https://blog.discourse.org/2017/12/discourse-gives-back-2017/

What I like about that information was not only the choice of free software projects and the amount donated to each, but the comprehensive explanation about the function each project plays in the free software product this organization is developing.

With or without donations, it would be interesting to set ourselves to a similar exercise.

Mooeypoo updated the task description. (Show Details)Jan 23 2018, 5:59 PM
Krinkle updated the task description. (Show Details)Jan 23 2018, 10:47 PM
Krinkle updated the task description. (Show Details)Jan 23 2018, 10:52 PM
Quiddity updated the task description. (Show Details)Feb 5 2018, 11:56 PM
Quiddity added a subscriber: Quiddity.

For your watchlisting/cleaning/discussion interests the etherpad notes were copied to https://www.mediawiki.org/wiki/Wikimedia_Developer_Summit/2018/Embracing_Open_Source_Software

@Matanya @MSchottlender-WMF Thank you for organizing your session at the 2018 Dev Summit. Please make sure to document your outcomes, next steps and link to any tasks that were created as outcomes of this session. Otherwise please resolve this and corresponding Phabricator tasks when there is nothing left to do in those tasks.

Rfarrand closed this task as Resolved.Jun 26 2018, 7:37 PM
Rfarrand claimed this task.